mod xapcm;

use super::Arguments;
use super::raw_audio::PreparedAudioSamples;
use std::io::Write;
use tool_helper::Error;

const HIGH_FREQUENCY:u32 = 37_800;
const  LOW_FREQUENCY:u32 = 18_900;

pub fn encode(input: PreparedAudioSamples, output: &mut dyn Write, arguments: &Arguments) -> Result<(), Error> {
    let mut encoder      = xapcm::Encoder::new(&input.samples(), arguments.clone(), input.orality());
    let mut sector_count = 0;

    while let Some(xa_sector) = encoder.encode_next_xa_sector()? {
        output.write(&xa_sector)?;

        sector_count += 1;
        print!("\rSector: {} written", sector_count);
    }
    println!();
    //Err(Error::not_implemented("XA conversion"))
    Ok(())
}